diff --git a/oflog/libsrc/patlay.cc b/oflog/libsrc/patlay.cc
index af0bbc4..4e30354 100644
--- a/oflog/libsrc/patlay.cc
+++ b/oflog/libsrc/patlay.cc
@@ -678,24 +829,16 @@ PatternParser::finalizeConverter(tchar c)
                 //else {
                 //    getLogLog().debug("LOCAL DATE converter.");
                 //}
-                //formattingInfo.dump(getLogLog());
+                //formattingInfo.dump(getLogLog());      
             }
             break;
 
-        case DCMTK_LOG4CPLUS_TEXT('f'):
-            pc = new BasicPatternConverter
-                          (formattingInfo,
-                           BasicPatternConverter::FUNCTION_CONVERTER);
-            //getLogLog().debug("FUNCTION NAME converter.");
-            //formattingInfo.dump(getLogLog());
-            break;
-
         case DCMTK_LOG4CPLUS_TEXT('F'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::FILE_CONVERTER);
             //getLogLog().debug("FILE NAME converter.");
-            //formattingInfo.dump(getLogLog());
+            //formattingInfo.dump(getLogLog());      
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('h'):
@@ -708,41 +851,56 @@ PatternParser::finalizeConverter(tchar c)
             }
             break;
 
+        case DCMTK_LOG4CPLUS_TEXT('i'):
+            pc = new BasicPatternConverter
+                          (formattingInfo, 
+                           BasicPatternConverter::PROCESS_CONVERTER);
+            //getLogLog().debug("PROCESS_CONVERTER converter.");
+            //formattingInfo.dump(getLogLog());      
+            break;
+
         case DCMTK_LOG4CPLUS_TEXT('l'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::FULL_LOCATION_CONVERTER);
             //getLogLog().debug("FULL LOCATION converter.");
-            //formattingInfo.dump(getLogLog());
+            //formattingInfo.dump(getLogLog());      
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('L'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::LINE_CONVERTER);
             //getLogLog().debug("LINE NUMBER converter.");
-            //formattingInfo.dump(getLogLog());
+            //formattingInfo.dump(getLogLog());      
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('m'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::MESSAGE_CONVERTER);
             //getLogLog().debug("MESSAGE converter.");
-            //formattingInfo.dump(getLogLog());
+            //formattingInfo.dump(getLogLog());      
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT('M'):
+            pc = new BasicPatternConverter (
+                formattingInfo, BasicPatternConverter::FUNCTION_CONVERTER);
+            //getLogLog().debug("METHOD (function name) converter.");
+            //formattingInfo.dump(getLogLog());   
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('n'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::NEWLINE_CONVERTER);
-            //getLogLog().debug("NEWLINE converter.");
-            //formattingInfo.dump(getLogLog());
+            //getLogLog().debug("MESSAGE converter.");
+            //formattingInfo.dump(getLogLog());      
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('p'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::LOGLEVEL_CONVERTER);
             //getLogLog().debug("LOGLEVEL converter.");
             //formattingInfo.dump(getLogLog());
@@ -750,33 +908,42 @@ PatternParser::finalizeConverter(tchar c)
 
         case DCMTK_LOG4CPLUS_TEXT('P'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::LOGLEVEL_PREFIX_CONVERTER);
-            //getLogLog().debug("LOGLEVEL PREFIX converter.");
+            //getLogLog().debug("LOGLEVEL converter.");
+            //formattingInfo.dump(getLogLog());
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT('r'):
+            pc = new RelativeTimestampConverter (formattingInfo);
+            //getLogLog().debug("RELATIVE converter.");
             //formattingInfo.dump(getLogLog());
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('t'):
             pc = new BasicPatternConverter
-                          (formattingInfo,
+                          (formattingInfo, 
                            BasicPatternConverter::THREAD_CONVERTER);
             //getLogLog().debug("THREAD converter.");
-            //formattingInfo.dump(getLogLog());
+            //formattingInfo.dump(getLogLog());      
             break;
 
-        case DCMTK_LOG4CPLUS_TEXT('i'):
+        case DCMTK_LOG4CPLUS_TEXT('T'):
             pc = new BasicPatternConverter
                           (formattingInfo,
-                           BasicPatternConverter::PROCESS_CONVERTER);
-            //getLogLog().debug("PROCESS_CONVERTER converter.");
+                           BasicPatternConverter::THREAD2_CONVERTER);
+            //getLogLog().debug("THREAD2 converter.");
             //formattingInfo.dump(getLogLog());
             break;
 
         case DCMTK_LOG4CPLUS_TEXT('x'):
-            pc = new BasicPatternConverter
-                          (formattingInfo,
-                           BasicPatternConverter::NDC_CONVERTER);
-            //getLogLog().debug("NDC converter.");
+            pc = new NDCPatternConverter (formattingInfo, ndcMaxDepth);
+            //getLogLog().debug("NDC converter.");      
+            break;
+
+        case DCMTK_LOG4CPLUS_TEXT('X'):
+            pc = new MDCPatternConverter (formattingInfo, extractOption ());
+            //getLogLog().debug("MDC converter.");
             break;
 
         default:
@@ -785,89 +952,93 @@ PatternParser::finalizeConverter(tchar c)
                 << c
                 << DCMTK_LOG4CPLUS_TEXT("] at position ")
                 << pos
-                << DCMTK_LOG4CPLUS_TEXT(" in conversion pattern.");
-            OFSTRINGSTREAM_GETOFSTRING(buf, str)
-            getLogLog().error(str);
+                << DCMTK_LOG4CPLUS_TEXT(" in conversion patterrn.");
+            helpers::getLogLog().error(OFString(buf.str().c_str(), buf.str().length()));
             pc = new LiteralPatternConverter(currentLiteral);
     }
 
+    list.push_back(pc);
     currentLiteral.resize(0);
-    list->push_back(pc);
     state = LITERAL_STATE;
     formattingInfo.reset();
 }
 
 
+} // namespace pattern
+
 
+typedef pattern::PatternConverterList PatternConverterList;
 
 
 ////////////////////////////////////////////////
 // PatternLayout methods:
 ////////////////////////////////////////////////
 
-PatternLayout::PatternLayout(const tstring& pattern_, bool formatEachLine_)
+PatternLayout::PatternLayout(const tstring& pattern_)
+    : pattern()
+    , parsedPattern()
 {
-    init(pattern_, formatEachLine_);
+    init(pattern_, 0);
 }
 
 
-PatternLayout::PatternLayout(const Properties& properties, tstring& error)
+PatternLayout::PatternLayout(const helpers::Properties& properties)
+    : pattern()
+    , parsedPattern()
 {
+    unsigned ndcMaxDepth = 0;
+    properties.getUInt (ndcMaxDepth, DCMTK_LOG4CPLUS_TEXT ("NDCMaxDepth"));
+
     bool hasPattern = properties.exists( DCMTK_LOG4CPLUS_TEXT("Pattern") );
     bool hasConversionPattern = properties.exists( DCMTK_LOG4CPLUS_TEXT("ConversionPattern") );
-    tstring eachLine = properties.getProperty( DCMTK_LOG4CPLUS_TEXT("FormatEachLine"), "yes");
-    bool formatEachLine_ = true;
-
-    if (eachLine == DCMTK_LOG4CPLUS_TEXT("yes"))
-        formatEachLine_ = true;
-    else if (eachLine == DCMTK_LOG4CPLUS_TEXT("no"))
-        formatEachLine_ = false;
-    else
-        getLogLog().warn( DCMTK_LOG4CPLUS_TEXT("PatternLayout- the \"FormatEachLine\" property has an invalid value, assuming \"yes\""));
-
+    
     if(hasPattern) {
-        getLogLog().warn( DCMTK_LOG4CPLUS_TEXT("PatternLayout- the \"Pattern\" property has been deprecated.  Use \"ConversionPattern\" instead."));
+        helpers::getLogLog().warn(
+            DCMTK_LOG4CPLUS_TEXT("PatternLayout- the \"Pattern\" property has been")
+            DCMTK_LOG4CPLUS_TEXT(" deprecated.  Use \"ConversionPattern\" instead."));
     }
-
+    
     if(hasConversionPattern) {
-        init(properties.getProperty( DCMTK_LOG4CPLUS_TEXT("ConversionPattern") ), formatEachLine_);
+        init(properties.getProperty( DCMTK_LOG4CPLUS_TEXT("ConversionPattern") ),
+            ndcMaxDepth);
     }
     else if(hasPattern) {
-        init(properties.getProperty( DCMTK_LOG4CPLUS_TEXT("Pattern") ), formatEachLine_);
+        init(properties.getProperty( DCMTK_LOG4CPLUS_TEXT("Pattern") ), ndcMaxDepth);
     }
     else {
-        error = DCMTK_LOG4CPLUS_TEXT("ConversionPattern not specified in properties");
-        //throw STD_NAMESPACE runtime_error("ConversionPattern not specified in properties");
-        return;
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT ("ConversionPattern not specified in properties"),
+            true);
     }
-    error.clear();
+
 }
 
 
 void
-PatternLayout::init(const tstring& pattern_, bool formatEachLine_)
+PatternLayout::init(const tstring& pattern_, unsigned ndcMaxDepth)
 {
-    this->pattern = pattern_;
-    this->formatEachLine = formatEachLine_;
-    this->parsedPattern = PatternParser(pattern).parse();
+    pattern = pattern_;
+    parsedPattern = pattern::PatternParser(pattern, ndcMaxDepth).parse();
 
     // Let's validate that our parser didn't give us any NULLs.  If it did,
     // we will convert them to a valid PatternConverter that does nothing so
     // at least we don't core.
-    for(PatternConverterListIterator it=parsedPattern->begin();
-        it!=parsedPattern->end();
+    for(PatternConverterList::iterator it=parsedPattern.begin(); 
+        it!=parsedPattern.end(); 
         ++it)
     {
         if( (*it) == 0 ) {
-            getLogLog().error(DCMTK_LOG4CPLUS_TEXT("Parsed Pattern created a NULL PatternConverter"));
-            (*it) = new LiteralPatternConverter( DCMTK_LOG4CPLUS_TEXT("") );
+            helpers::getLogLog().error(
+                DCMTK_LOG4CPLUS_TEXT("Parsed Pattern created a NULL PatternConverter"));
+            (*it) = new pattern::LiteralPatternConverter( DCMTK_LOG4CPLUS_TEXT("") );
         }
     }
-    if(parsedPattern->size() == 0) {
-        getLogLog().warn(DCMTK_LOG4CPLUS_TEXT("PatternLayout pattern is empty.  Using default..."));
-        parsedPattern->push_back
-           (new BasicPatternConverter(FormattingInfo(),
-                                      BasicPatternConverter::MESSAGE_CONVERTER));
+    if(parsedPattern.empty ()) {
+        helpers::getLogLog().warn(
+            DCMTK_LOG4CPLUS_TEXT("PatternLayout pattern is empty.  Using default..."));
+        parsedPattern.push_back (
+            new pattern::BasicPatternConverter(pattern::FormattingInfo(), 
+            pattern::BasicPatternConverter::MESSAGE_CONVERTER));
     }
 }
 
@@ -875,10 +1046,8 @@ PatternLayout::init(const tstring& pattern_, bool formatEachLine_)
 
 PatternLayout::~PatternLayout()
 {
-    if (parsedPattern.get() == NULL)
-        return;
-    for(PatternConverterListIterator it=parsedPattern->begin();
-        it!=parsedPattern->end();
+    for(PatternConverterList::iterator it=parsedPattern.begin(); 
+        it!=parsedPattern.end(); 
         ++it)
     {
         delete (*it);
@@ -888,41 +1057,17 @@ PatternLayout::~PatternLayout()
 
 
 void
-PatternLayout::formatAndAppend(tostream& output,
-                               const InternalLoggingEvent& event)
+PatternLayout::formatAndAppend(tostream& output, 
+                               const spi::InternalLoggingEvent& event)
 {
-    if (formatEachLine && event.getMessage().find('\n') != OFString_npos)
-    {
-        size_t pos = 0;
-        size_t last_pos = 0;
-
-        while (pos != OFString_npos)
-        {
-            pos = event.getMessage().find('\n', last_pos);
-
-            // Create a substring from just this single line
-            tstring tmp_message(event.getMessage().substr(last_pos, (pos == OFString_npos) ? pos : pos - last_pos));
-
-            // Then create a temporary InternalLoggingEvent for this one line
-            InternalLoggingEvent tmp_event(event.getLoggerName(), event.getLogLevel(),
-                event.getNDC(), tmp_message, event.getThread(), event.getTimestamp(),
-                event.getFile(), event.getLine(), event.getFunction());
-            // And finally, log this single line
-            formatAndAppend(output, tmp_event);
-
-            // Skip the "\n"
-            last_pos = pos + 1;
-        }
-    }
-    else
+    for(PatternConverterList::iterator it=parsedPattern.begin(); 
+        it!=parsedPattern.end(); 
+        ++it)
     {
-        for(PatternConverterListIterator it=parsedPattern->begin();
-            it!=parsedPattern->end();
-            ++it)
-        {
-            (*it)->formatAndAppend(output, event);
-        }
+        (*it)->formatAndAppend(output, event);
     }
 }
 
 
+} // namespace log4cplus
+} // end namespace dcmtk
diff --git a/oflog/libsrc/pointer.cc b/oflog/libsrc/pointer.cc
index 06c7472..16b8867 100644
--- a/oflog/libsrc/pointer.cc
+++ b/oflog/libsrc/pointer.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,51 +20,96 @@
 
 #include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/helpers/pointer.h"
-#include "dcmtk/oflog/helpers/threads.h"
-//#include <assert.h>
+#include "dcmtk/oflog/thread/threads.h"
+#include "dcmtk/oflog/thread/impl/syncimpl.h"
+#include "dcmtk/oflog/config/windowsh.h"
+#include <cassert>
+#if defined (DCMTK_LOG4CPLUS_HAVE_INTRIN_H)
+#include <intrin.h>
+#endif
 
 
-namespace dcmtk { namespace log4cplus { namespace helpers {
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::SharedObject dtor
+// log4cplus::helpers::SharedObject dtor
 ///////////////////////////////////////////////////////////////////////////////
 
 SharedObject::~SharedObject()
 {
     assert(count == 0);
-    DCMTK_LOG4CPLUS_MUTEX_FREE( access_mutex );
 }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::helpers::SharedObject public methods
+// log4cplus::helpers::SharedObject public methods
 ///////////////////////////////////////////////////////////////////////////////
 
 void
 SharedObject::addReference() const
 {
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex )
-        assert (count >= 0);
-        ++count;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
+#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+    ++count;
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE_CXX11_ATOMICS)
+    STD_NAMESPACE atomic_fetch_add_explicit (&count, 1u,
+        STD_NAMESPACE memory_order_relaxed);
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE___SYNC_ADD_AND_FETCH)
+    __sync_add_and_fetch (&count, 1);
+
+#elif defined (_WIN32) && defined (DCMTK_LOG4CPLUS_HAVE_INTRIN_H)
+    _InterlockedIncrement (&count);
+
+#elif defined (_WIN32)
+    InterlockedIncrement (&count);
+
+#else
+    thread::MutexGuard guard (access_mutex);
+    ++count;
+
+#endif
 }
 
 
 void
 SharedObject::removeReference() const
 {
-    bool destroy = false;
-    DCMTK_LOG4CPLUS_BEGIN_SYNCHRONIZE_ON_MUTEX( access_mutex );
-        assert (count > 0);
-        if (--count == 0)
-            destroy = true;
-    DCMTK_LOG4CPLUS_END_SYNCHRONIZE_ON_MUTEX;
-    if (destroy)
+    assert (count > 0);
+    bool destroy;
+
+#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+    destroy = --count == 0;
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE_CXX11_ATOMICS)
+    destroy = STD_NAMESPACE atomic_fetch_sub_explicit (&count, 1u,
+        STD_NAMESPACE memory_order_release) == 1;
+    if (DCMTK_LOG4CPLUS_UNLIKELY (destroy))
+        STD_NAMESPACE atomic_thread_fence (STD_NAMESPACE memory_order_acquire);
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE___SYNC_SUB_AND_FETCH)
+    destroy = __sync_sub_and_fetch (&count, 1) == 0;
+
+#elif defined (_WIN32) && defined (DCMTK_LOG4CPLUS_HAVE_INTRIN_H)
+    destroy = _InterlockedDecrement (&count) == 0;
+
+#elif defined (_WIN32)
+    destroy = InterlockedDecrement (&count) == 0;
+
+#else
+    {
+        thread::MutexGuard guard (access_mutex);
+        destroy = --count == 0;
+    }
+
+#endif
+    if (DCMTK_LOG4CPLUS_UNLIKELY (destroy))
         delete this;
 }
 
 
-} } } // namespace dcmtk { namespace log4cplus { namespace helpers
+} } // namespace log4cplus { namespace helpers
+} // end namespace dcmtk
diff --git a/oflog/libsrc/property.cc b/oflog/libsrc/property.cc
index 1b60a97..85b55d8 100644
--- a/oflog/libsrc/property.cc
+++ b/oflog/libsrc/property.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2002-2009 Tad E. Smith
+// Copyright 2002-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,24 +18,36 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
-//#include <cstring>
+#include "dcmtk/oflog/config.h"
+
+#include <cstring>
 #if defined (UNICODE)
-//#  include <cwctype>
+#  include <cwctype>
 #else
-//#  include <cctype>
+#  include <cctype>
 #endif
-#include "dcmtk/oflog/helpers/property.h"
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF8_FACET) \
+    || defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF16_FACET) \
+    || defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF32_FACET)
+#  include <codecvt>
+#endif
+#include <locale>
+#include <fstream>
+#include <sstream>
+#include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/fstreams.h"
+#include "dcmtk/oflog/helpers/strhelp.h"
+#include "dcmtk/oflog/helpers/property.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include "dcmtk/oflog/internal/env.h"
+#include "dcmtk/oflog/helpers/loglog.h"
 
 
-namespace dcmtk
-{
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
 
-namespace log4cplus
-{
 
-
-const tchar helpers::Properties::PROPERTIES_COMMENT_CHAR = DCMTK_LOG4CPLUS_TEXT('#');
+const tchar Properties::PROPERTIES_COMMENT_CHAR = DCMTK_LOG4CPLUS_TEXT('#');
 
 
 namespace
@@ -46,7 +58,11 @@ static
 int
 is_space (tchar ch)
 {
+#if defined (UNICODE)
+    return STD_NAMESPACE iswspace (ch);
+#else
     return isspace (OFstatic_cast(unsigned char, ch));
+#endif
 }
 
 
@@ -60,7 +76,7 @@ trim_leading_ws (tstring & str)
         if (! is_space (*it))
             break;
     }
-    str.erase (0, it - str.begin());
+    str.erase (0, it - str.begin ());
 }
 
 
@@ -68,13 +84,13 @@ static
 void
 trim_trailing_ws (tstring & str)
 {
-    tstring::iterator it = str.end();
-    for (; it != str.begin(); --it)
-     {
-        if (! is_space (*(it - 1)))
-             break;
-     }
-    str.resize(it - str.begin());
+    size_t i;
+    for (i = str.length(); i > 0; i--)
+    {
+        if (! is_space (str[i-1]))
+            break;
+    }
+    str.erase (i, str.length() - i);
 }
 
 
@@ -91,55 +107,101 @@ trim_ws (tstring & str)
 
 
 
-namespace helpers
-{
-
 ///////////////////////////////////////////////////////////////////////////////
 // Properties ctors and dtor
 ///////////////////////////////////////////////////////////////////////////////
 
-Properties::Properties()
+Properties::Properties() : data()
 {
 }
 
 
 
-Properties::Properties(tistream& input)
+Properties::Properties(tistream& input) : data()
 {
     init(input);
 }
 
 
 
-Properties::Properties(const tstring& inputFile)
+Properties::Properties(const tstring& inputFile, unsigned flags) : data()
 {
-    if (inputFile.length() == 0)
+    if (inputFile.empty ())
         return;
 
-    tifstream file (DCMTK_LOG4CPLUS_TSTRING_TO_STRING(inputFile).c_str());
+    tifstream file;
+
+    switch (flags & fEncodingMask)
+    {
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF8_FACET) && defined (UNICODE)
+    case fUTF8:
+        file.imbue (
+            STD_NAMESPACE locale (file.getloc (),
+                new STD_NAMESPACE codecvt_utf8<tchar, 0x10FFFF,
+                    OFstatic_cast(STD_NAMESPACE codecvt_mode, STD_NAMESPACE consume_header | STD_NAMESPACE little_endian)>));
+        break;
+#endif
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF16_FACET) && defined (UNICODE)
+    case fUTF16:
+        file.imbue (
+            STD_NAMESPACE locale (file.getloc (),
+                new STD_NAMESPACE codecvt_utf16<tchar, 0x10FFFF,
+                    OFstatic_cast(STD_NAMESPACE codecvt_mode, STD_NAMESPACE consume_header | STD_NAMESPACE little_endian)>));
+        break;
+
+#elif defined (UNICODE) && defined (WIN32)
+    case fUTF16:
+        file.imbue (
+            STD_NAMESPACE locale (file.getloc (),
+                new STD_NAMESPACE codecvt<wchar_t, wchar_t, STD_NAMESPACE mbstate_t>));
+    break;
+
+#endif
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF32_FACET) && defined (UNICODE)
+    case fUTF32:
+        file.imbue (
+            STD_NAMESPACE locale (file.getloc (),
+                new STD_NAMESPACE codecvt_utf32<tchar, 0x10FFFF,
+                    OFstatic_cast(STD_NAMESPACE codecvt_mode, STD_NAMESPACE consume_header | STD_NAMESPACE little_endian)>));
+        break;
+#endif
+
+    case fUnspecEncoding:;
+    default:
+        // Do nothing.
+        ;
+    }
+
+    file.open(DCMTK_LOG4CPLUS_FSTREAM_PREFERED_FILE_NAME(inputFile).c_str(),
+        STD_NAMESPACE ios::binary);
+    if (! file.good ())
+        helpers::getLogLog ().error (DCMTK_LOG4CPLUS_TEXT ("could not open file ")
+            + inputFile);
+
     init(file);
 }
 
 
 
-void
-Properties::init(tistream& input)
+void 
+Properties::init(tistream& input) 
 {
     if (! input)
         return;
 
-    // FIXME
     STD_NAMESPACE string buffer_;
     while (STD_NAMESPACE getline (input, buffer_))
     {
-        tstring buffer(buffer_.c_str());
+        tstring buffer(buffer_.c_str(), buffer_.length());
         trim_leading_ws (buffer);
 
         tstring::size_type const buffLen = buffer.size ();
         if (buffLen == 0 || buffer[0] == PROPERTIES_COMMENT_CHAR)
             continue;
-
-        // Check if we have a trailing \r because we are
+        
+        // Check if we have a trailing \r because we are 
         // reading a properties file produced on Windows.
         if (buffer[buffLen-1] == DCMTK_LOG4CPLUS_TEXT('\r'))
             // Remove trailing 'Windows' \r.
@@ -159,31 +221,47 @@ Properties::init(tistream& input)
 
 
 
-Properties::~Properties()
+Properties::~Properties() 
 {
 }
 
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// Properties public methods
+// helpers::Properties public methods
 ///////////////////////////////////////////////////////////////////////////////
 
-tstring
-Properties::getProperty(const tstring& key) const
+
+bool
+Properties::exists(const log4cplus::tstring& key) const
 {
-    StringMap::const_iterator it (data.find(key));
-    if (it == data.end())
-        return DCMTK_LOG4CPLUS_TEXT("");
-    else
-        return it->second;
+    return data.find(key) != data.end();
+}
+
+
+bool
+Properties::exists(tchar const * key) const
+{
+    return data.find(key) != data.end();
+}
+
+
+tstring const &
+Properties::getProperty(const tstring& key) const 
+{
+    return get_property_worker (key);
 }
 
 
+log4cplus::tstring const &
+Properties::getProperty(tchar const * key) const
+{
+    return get_property_worker (key);
+}
+
 
 tstring
-Properties::getProperty(const tstring& key,
-                                 const tstring& defaultVal) const
+Properties::getProperty(const tstring& key, const tstring& defaultVal) const
 {
     StringMap::const_iterator it (data.find (key));
     if (it == data.end ())
@@ -193,10 +271,10 @@ Properties::getProperty(const tstring& key,
 }
 
 
-OFList<tstring>
-Properties::propertyNames() const
+OFVector<tstring>
+Properties::propertyNames() const 
 {
-    OFList<tstring> tmp;
+    OFVector<tstring> tmp;
     for (StringMap::const_iterator it=data.begin(); it!=data.end(); ++it)
         tmp.push_back(it->first);
 
@@ -206,28 +284,27 @@ Properties::propertyNames() const
 
 
 void
-Properties::setProperty(const tstring& key, const tstring& value)
+Properties::setProperty(const log4cplus::tstring& key,
+    const log4cplus::tstring& value)
 {
     data[key] = value;
 }
 
 
 bool
-Properties::removeProperty(const tstring& key)
+Properties::removeProperty(const log4cplus::tstring& key)
 {
-    return (data.erase(key) > 0);
+    return data.erase(key) > 0;
 }
 
 
-Properties
-Properties::getPropertySubset(
-    const tstring& prefix) const
+Properties 
+Properties::getPropertySubset(const log4cplus::tstring& prefix) const
 {
     Properties ret;
-    OFList<tstring> const keys = propertyNames();
     size_t const prefix_len = prefix.size ();
-    for (OFListConstIterator(tstring) it = keys.begin();
-        it != keys.end(); ++it)
+    OFVector<tstring> keys = propertyNames();
+    for (OFVector<tstring>::iterator it=keys.begin(); it!=keys.end(); ++it)
     {
         int result = it->compare (0, prefix_len, prefix);
         if (result == 0)
@@ -237,8 +314,82 @@ Properties::getPropertySubset(
     return ret;
 }
 
-} // namespace helpers
 
-} // namespace log4cplus
+bool
+Properties::getInt (int & val, log4cplus::tstring const & key) const
+{
+    return get_type_val_worker (val, key);
+}
+
+
+bool
+Properties::getUInt (unsigned & val, log4cplus::tstring const & key) const
+{
+    return get_type_val_worker (val, key);
+}
+
+
+bool
+Properties::getLong (long & val, log4cplus::tstring const & key) const
+{
+    return get_type_val_worker (val, key);
+}
+
+
+bool
+Properties::getULong (unsigned long & val, log4cplus::tstring const & key) const
+{
+    return get_type_val_worker (val, key);
+}
+
+
+bool
+Properties::getBool (bool & val, log4cplus::tstring const & key) const
+{
+    if (! exists (key))
+        return false;
+
+    log4cplus::tstring const & prop_val = getProperty (key);
+    return internal::parse_bool (val, prop_val);
+}
+
+
+template <typename StringType>
+log4cplus::tstring const &
+Properties::get_property_worker (StringType const & key) const
+{
+    StringMap::const_iterator it (data.find (key));
+    if (it == data.end ())
+        return log4cplus::internal::empty_str;
+    else
+        return it->second;
+}
+
+
+template <typename ValType>
+bool
+Properties::get_type_val_worker (ValType & val, log4cplus::tstring const & key)
+    const
+{
+    if (! exists (key))
+        return false;
+
+    log4cplus::tstring const & prop_val = getProperty (key);
+    log4cplus::tistringstream iss (STD_NAMESPACE string(prop_val.c_str(), prop_val.length()));
+    ValType tmp_val;
+    tchar ch;
+
+    iss >> tmp_val;
+    if (! iss)
+        return false;
+    iss >> ch;
+    if (iss)
+        return false;
+
+    val = tmp_val;
+    return true;
+}
+
 
-} // namespace dcmtk
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
